<template>
  <v-ons-page>
    <v-ons-toolbar>
      <div class="left">
        <v-ons-icon icon="ion-ios-arrow-back" size="lg" @click="redirect('/', {tab: 'wallet'})"></v-ons-icon>
      </div>
      <div class="center">Send Coins</div>
      <div class="right">
        <v-ons-toolbar-button icon="ion-navicon"></v-ons-toolbar-button>
      </div>
    </v-ons-toolbar>

    <div class="send-coins-container">
      <p>Enter username to send coins</p>
      <q-reader :onDetectQR="onDetectUsername" :scanning="showScanner" />
      <v-ons-button
        v-if="showScanner"
        class="new-message-btn"
        modifier="quiet"
        @click="onClickQRScanner"
      >Close QR Scanner</v-ons-button>
      <div class="send-username-input-container">
        <input type="text" placeholder="Username" v-model="username" class="send-username-input" />
        <v-ons-button modifier="quiet" @click="onClickQRScanner" class="qr-code-btn">
          <img src="../../assets/qrcode.png" alt="qr-code" />
        </v-ons-button>
      </div>
      <p>Enter amount to send</p>
      <div class="send-amount-input-container">
        <input type="text" placeholder="Amount" v-model="amount" class="send-username-input send-amount-input" />
        <p
          class="input-error-message"
          v-if="$v.amount.required && !$v.amount.between"
        >Invalid amount</p>
      </div>
      <v-ons-button
        :disabled="!isFormValid"
        class="create-user-btn default-btn"
        @click="onSend"
      >Send</v-ons-button>
    </div>
  </v-ons-page>
</template>

<script>
import Vue from "vue";
import "onsenui/css/onsenui.css";
import "onsenui/css/onsen-css-components.css";
import VueOnsen from "vue-onsenui/esm";
import OnsenComponents from "~/components/Onsen";
import ChatText from "~/components/ChatText";
import ChatInput from "~/components/ChatInput";
import QReader from "~/components/QReader";
import { mapGetters, mapActions } from "vuex";
import utils from "../../assets/utils";
import Vuelidate from "vuelidate";
import { required, minLength, between } from "vuelidate/lib/validators";
Vue.use(VueOnsen);
Vue.use(Vuelidate);
Object.values(OnsenComponents).forEach(c => Vue.component(c.name, c));

export default {
  components: {
    QReader
  },
  data: function() {
    return {
      username: "",
      amount: "",
      previousUrl: "/",
      showScanner: false
    };
  },
  validations: {
    username: {
      required,
      minLength: minLength(1)
    },
    amount: {
      required,
      between: between(1, 1000)
    }
  },
  computed: {
    ...mapGetters({
      getWallet: "wallet/getWallet",
      getAppState: "chat/getAppState",
      isUIReady: "chat/isUIReady"
    }),
    isFormValid() {
      if (
        !this.$v.username.required ||
        !this.$v.amount.required ||
        !this.$v.amount.between
      )
        return false;
      return true;
    }
  },
  beforeRouteEnter(to, from, next) {
    next(vm => {
      vm.previousUrl = from.path;
    });
  },
  methods: {
    redirect(url, option) {
      this.$router.push(url);
    },
    onDetectUsername(name) {
      this.username = name;
      this.showScanner = false;
    },
    onClickQRScanner() {
      this.showScanner = !this.showScanner;
    },
    async onSend() {
      let isSubmitted = await utils.transferTokens(
        this.username,
        this.amount,
        this.getWallet.entry.keys
      );
      if (isSubmitted) {
        this.$ons.notification.alert("Transfer tx is submitted.");
        this.username = "";
        this.amount = "";
        this.redirect("/");
      }
    }
  }
};
</script>

<style>
.send-coins-container {
  text-align: center;
  margin-top: 30px;
  width: 80%;
  max-width: 300px;
  margin: 30px auto;
}
.send-coins-container p {
  text-align: left;
  font-weight: bold;
}
.secret-key-input {
  margin-right: 5px;
}
.qr-code-btn {
  height: 40px;
  padding: 5px;
}
.send-username-input-container {
  display: flex;
  justify-content: space-between;
  align-items: center;
  height: 80px;
  margin-bottom: 10px;
}
.send-amount-input-container {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  align-items: flex-start;
  height: 80px;
  margin-bottom: 10px;
}
.send-username-input {
  height: 40px;
  width: 90%;
  max-width: 300px;
  padding: 5px 10px;
  background: #fff;
  border: 1px solid #dddddd;
  border-radius: 5px;
  margin: 20px 0px;
  margin-bottom: 5px;
}
.send-username-input.send-amount-input {
  width: 100%;
}
.input-error-message {
  color: red;
  font-weight: normal !important;
}
</style>
